/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/simulator_gazebo/gazebo_plugins/msg/ContactState.msg.  Do not edit! */
#ifndef GAZEBO_PLUGINS_CONTACTSTATE_H
#define GAZEBO_PLUGINS_CONTACTSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Vector3.h"
#include "geometry_msgs/Wrench.h"

namespace gazebo_plugins
{

//! \htmlinclude ContactState.msg.html

class ContactState : public ros::Message
{
public:
  typedef boost::shared_ptr<ContactState> Ptr;
  typedef boost::shared_ptr<ContactState const> ConstPtr;

  typedef std::string _info_type;
  typedef std::string _geom1_name_type;
  typedef std::string _geom2_name_type;
  typedef std::vector<geometry_msgs::Wrench> _wrenches_type;
  typedef std::vector<geometry_msgs::Vector3> _contact_positions_type;
  typedef std::vector<geometry_msgs::Vector3> _contact_normals_type;
  typedef std::vector<double> _depths_type;

  std::string info;
  std::string geom1_name;
  std::string geom2_name;
  std::vector<geometry_msgs::Wrench> wrenches;
  std::vector<geometry_msgs::Vector3> contact_positions;
  std::vector<geometry_msgs::Vector3> contact_normals;
  std::vector<double> depths;

  ContactState() : ros::Message()
  {
  }
  ContactState(const ContactState &copy) : ros::Message(),
    info(copy.info),
    geom1_name(copy.geom1_name),
    geom2_name(copy.geom2_name)
  {
    (void)copy;
    wrenches = copy.wrenches;
    contact_positions = copy.contact_positions;
    contact_normals = copy.contact_normals;
    depths = copy.depths;
  }
  ContactState &operator =(const ContactState &copy)
  {
    if (this == &copy)
      return *this;
    wrenches.clear();
    contact_positions.clear();
    contact_normals.clear();
    depths.clear();
    info = copy.info;
    geom1_name = copy.geom1_name;
    geom2_name = copy.geom2_name;
    wrenches = copy.wrenches;
    contact_positions = copy.contact_positions;
    contact_normals = copy.contact_normals;
    depths = copy.depths;
    return *this;
  }
  virtual ~ContactState() 
  {
    wrenches.clear();
    contact_positions.clear();
    contact_normals.clear();
    depths.clear();
  }
  inline static std::string __s_getDataType() { return std::string("gazebo_plugins/ContactState"); }
  inline static std::string __s_getMD5Sum() { return std::string("0810b2ddb2829d16562fb583d2db4993"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "string info                                   # text info on this contact\n"
    "string geom1_name                             # name of contact geom1\n"
    "string geom2_name                             # name of contact geom2\n"
    "geometry_msgs/Wrench[] wrenches               # list of forces/torques\n"
    "geometry_msgs/Vector3[] contact_positions     # list of contact position\n"
    "geometry_msgs/Vector3[] contact_normals       # list of contact normals\n"
    "float64[] depths                              # list of penetration depths\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Wrench\n"
    "# This represents force in free space, seperated into \n"
    "# it's linear and angular parts.  \n"
    "Vector3  force\n"
    "Vector3  torque\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_wrenches_size(uint32_t __ros_new_size)
  {
    this->wrenches.resize(__ros_new_size);
  }
  inline uint32_t get_wrenches_size() const { return wrenches.size(); }
  inline void get_wrenches_vec (std::vector<geometry_msgs::Wrench> &__ros_vec) const
  {
    __ros_vec = this->wrenches;
  }
  inline void set_wrenches_vec(const std::vector<geometry_msgs::Wrench> &__ros_vec)
  {
    this->wrenches = __ros_vec;
  }
  void set_contact_positions_size(uint32_t __ros_new_size)
  {
    this->contact_positions.resize(__ros_new_size);
  }
  inline uint32_t get_contact_positions_size() const { return contact_positions.size(); }
  inline void get_contact_positions_vec (std::vector<geometry_msgs::Vector3> &__ros_vec) const
  {
    __ros_vec = this->contact_positions;
  }
  inline void set_contact_positions_vec(const std::vector<geometry_msgs::Vector3> &__ros_vec)
  {
    this->contact_positions = __ros_vec;
  }
  void set_contact_normals_size(uint32_t __ros_new_size)
  {
    this->contact_normals.resize(__ros_new_size);
  }
  inline uint32_t get_contact_normals_size() const { return contact_normals.size(); }
  inline void get_contact_normals_vec (std::vector<geometry_msgs::Vector3> &__ros_vec) const
  {
    __ros_vec = this->contact_normals;
  }
  inline void set_contact_normals_vec(const std::vector<geometry_msgs::Vector3> &__ros_vec)
  {
    this->contact_normals = __ros_vec;
  }
  void set_depths_size(uint32_t __ros_new_size)
  {
    this->depths.resize(__ros_new_size);
  }
  inline uint32_t get_depths_size() const { return depths.size(); }
  inline void get_depths_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->depths;
  }
  inline void set_depths_vec(const std::vector<double> &__ros_vec)
  {
    this->depths = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + info.length(); // info
    __l += 4 + geom1_name.length(); // geom1_name
    __l += 4 + geom2_name.length(); // geom2_name
    __l += 4 + (wrenches.size() ? wrenches.size() * wrenches[0].serializationLength() : 0); // wrenches
    __l += 4 + (contact_positions.size() ? contact_positions.size() * contact_positions[0].serializationLength() : 0); // contact_positions
    __l += 4 + (contact_normals.size() ? contact_normals.size() * contact_normals[0].serializationLength() : 0); // contact_normals
    __l += 4 + (depths.size() ? depths.size() * 8 : 0); // depths
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_info_len = info.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_info_len);
    SROS_SERIALIZE_BUFFER(write_ptr, info.c_str(), __ros_info_len);
    unsigned __ros_geom1_name_len = geom1_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_geom1_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, geom1_name.c_str(), __ros_geom1_name_len);
    unsigned __ros_geom2_name_len = geom2_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_geom2_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, geom2_name.c_str(), __ros_geom2_name_len);
    uint32_t __wrenches_size = wrenches.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __wrenches_size);
    for (size_t i = 0; i < __wrenches_size; i++)
      write_ptr = wrenches[i].serialize(write_ptr, seq);
    uint32_t __contact_positions_size = contact_positions.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __contact_positions_size);
    for (size_t i = 0; i < __contact_positions_size; i++)
      write_ptr = contact_positions[i].serialize(write_ptr, seq);
    uint32_t __contact_normals_size = contact_normals.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __contact_normals_size);
    for (size_t i = 0; i < __contact_normals_size; i++)
      write_ptr = contact_normals[i].serialize(write_ptr, seq);
    uint32_t __depths_size = depths.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __depths_size);
    memcpy(write_ptr, &depths[0], sizeof(double) * __depths_size);
    write_ptr += sizeof(double) * __depths_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_info_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_info_len);
    info = std::string((const char *)read_ptr, __ros_info_len);
    read_ptr += __ros_info_len;
    unsigned __ros_geom1_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_geom1_name_len);
    geom1_name = std::string((const char *)read_ptr, __ros_geom1_name_len);
    read_ptr += __ros_geom1_name_len;
    unsigned __ros_geom2_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_geom2_name_len);
    geom2_name = std::string((const char *)read_ptr, __ros_geom2_name_len);
    read_ptr += __ros_geom2_name_len;
    uint32_t __wrenches_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __wrenches_size);
    set_wrenches_size(__wrenches_size);
    for (size_t i = 0; i < __wrenches_size; i++)
      read_ptr = wrenches[i].deserialize(read_ptr);
    uint32_t __contact_positions_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __contact_positions_size);
    set_contact_positions_size(__contact_positions_size);
    for (size_t i = 0; i < __contact_positions_size; i++)
      read_ptr = contact_positions[i].deserialize(read_ptr);
    uint32_t __contact_normals_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __contact_normals_size);
    set_contact_normals_size(__contact_normals_size);
    for (size_t i = 0; i < __contact_normals_size; i++)
      read_ptr = contact_normals[i].deserialize(read_ptr);
    uint32_t __depths_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __depths_size);
    set_depths_size(__depths_size);
    memcpy(&depths[0], read_ptr, sizeof(double) * __depths_size);
    read_ptr += sizeof(double) * __depths_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<ContactState> ContactStatePtr;
typedef boost::shared_ptr<ContactState const> ContactStateConstPtr;


}

#endif
