/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/simulator_gazebo/gazebo_plugins/msg/ContactsState.msg.  Do not edit! */
#ifndef GAZEBO_PLUGINS_CONTACTSSTATE_H
#define GAZEBO_PLUGINS_CONTACTSSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Vector3.h"
#include "geometry_msgs/Wrench.h"
#include "gazebo_plugins/ContactState.h"

namespace gazebo_plugins
{

//! \htmlinclude ContactsState.msg.html

class ContactsState : public ros::Message
{
public:
  typedef boost::shared_ptr<ContactsState> Ptr;
  typedef boost::shared_ptr<ContactsState const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<gazebo_plugins::ContactState> _states_type;

  roslib::Header header;
  std::vector<gazebo_plugins::ContactState> states;

  ContactsState() : ros::Message()
  {
  }
  ContactsState(const ContactsState &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    states = copy.states;
  }
  ContactsState &operator =(const ContactsState &copy)
  {
    if (this == &copy)
      return *this;
    states.clear();
    header = copy.header;
    states = copy.states;
    return *this;
  }
  virtual ~ContactsState() 
  {
    states.clear();
  }
  inline static std::string __s_getDataType() { return std::string("gazebo_plugins/ContactsState"); }
  inline static std::string __s_getMD5Sum() { return std::string("3faf37b14dd23b6abd0b6b1dfe846b7c"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "Header header                                   # stamp\n"
    "gazebo_plugins/ContactState[] states            # array of geom pairs in contact\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: gazebo_plugins/ContactState\n"
    "string info                                   # text info on this contact\n"
    "string geom1_name                             # name of contact geom1\n"
    "string geom2_name                             # name of contact geom2\n"
    "geometry_msgs/Wrench[] wrenches               # list of forces/torques\n"
    "geometry_msgs/Vector3[] contact_positions     # list of contact position\n"
    "geometry_msgs/Vector3[] contact_normals       # list of contact normals\n"
    "float64[] depths                              # list of penetration depths\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Wrench\n"
    "# This represents force in free space, seperated into \n"
    "# it's linear and angular parts.  \n"
    "Vector3  force\n"
    "Vector3  torque\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_states_size(uint32_t __ros_new_size)
  {
    this->states.resize(__ros_new_size);
  }
  inline uint32_t get_states_size() const { return states.size(); }
  uint32_t calc_states_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t states_size = states.size();
    for (size_t i = 0; i < states_size; i++)
      l += states[i].serializationLength();
    return l;
  }
  inline void get_states_vec (std::vector<gazebo_plugins::ContactState> &__ros_vec) const
  {
    __ros_vec = this->states;
  }
  inline void set_states_vec(const std::vector<gazebo_plugins::ContactState> &__ros_vec)
  {
    this->states = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_states_array_serialization_len(); // states
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __states_size = states.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __states_size);
    for (size_t i = 0; i < __states_size; i++)
      write_ptr = states[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __states_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __states_size);
    set_states_size(__states_size);
    for (size_t i = 0; i < __states_size; i++)
      read_ptr = states[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<ContactsState> ContactsStatePtr;
typedef boost::shared_ptr<ContactsState const> ContactsStateConstPtr;


}

#endif
