/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/simulator_gazebo/gazebo_plugins/msg/GazeboModel.msg.  Do not edit! */
#ifndef GAZEBO_PLUGINS_GAZEBOMODEL_H
#define GAZEBO_PLUGINS_GAZEBOMODEL_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"

namespace gazebo_plugins
{

//! \htmlinclude GazeboModel.msg.html

class GazeboModel : public ros::Message
{
public:
  typedef boost::shared_ptr<GazeboModel> Ptr;
  typedef boost::shared_ptr<GazeboModel const> ConstPtr;

  typedef std::string _model_name_type;
  typedef std::string _robot_model_type;
  typedef uint32_t _xml_type_type;
  typedef std::string _robot_namespace_type;
  typedef geometry_msgs::Pose _initial_pose_type;

  std::string model_name;
  std::string robot_model;
  uint32_t xml_type;
  std::string robot_namespace;
  geometry_msgs::Pose initial_pose;
  const static uint32_t disable_urdf_joint_limits = 0;
  const static uint32_t URDF = 0;
  const static uint32_t GAZEBO_XML = 1;
  const static uint32_t URDF_PARAM_NAME = 2;
  const static uint32_t GAZEBO_XML_PARAM_NAME = 3;
  const static uint32_t URDF_FILE_NAME = 4;
  const static uint32_t GAZEBO_XML_FILE_NAME = 5;

  GazeboModel() : ros::Message(),
    xml_type(0)
  {
  }
  GazeboModel(const GazeboModel &copy) : ros::Message(),
    model_name(copy.model_name),
    robot_model(copy.robot_model),
    xml_type(copy.xml_type),
    robot_namespace(copy.robot_namespace),
    initial_pose(copy.initial_pose)
  {
    (void)copy;
  }
  GazeboModel &operator =(const GazeboModel &copy)
  {
    if (this == &copy)
      return *this;
    model_name = copy.model_name;
    robot_model = copy.robot_model;
    xml_type = copy.xml_type;
    robot_namespace = copy.robot_namespace;
    initial_pose = copy.initial_pose;
    return *this;
  }
  virtual ~GazeboModel() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("gazebo_plugins/GazeboModel"); }
  inline static std::string __s_getMD5Sum() { return std::string("d714ee18a610705f8552f4aa20321c29"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This is a message that hold the data necessary to spawn a model in Gazebo\n"
    "# this message is used by SpawnModel service calls to RosFactory plugin.\n"
    "\n"
    "string model_name                        # name of the model to be spawned in Gazebo\n"
    "string robot_model                       # contains either URDF or Gazebo XML robot model\n"
    "uint32 xml_type                          # specifies what the content of robot_model is\n"
    "string robot_namespace                   # ros namespace for all the ros interface of the model\n"
    "geometry_msgs/Pose initial_pose          # initial pose in the gazebo world frame\n"
    "uint32 disable_urdf_joint_limits = 0     # special flag to disable URDF joint limits\n"
    "uint32 URDF                  = 0         # enum: robot_model contains XML string for an URDF model\n"
    "uint32 GAZEBO_XML            = 1         # enum: robot_model contains XML string for an URDF model\n"
    "uint32 URDF_PARAM_NAME       = 2         # enum: robot_model contains parameter name containing URDF XML\n"
    "uint32 GAZEBO_XML_PARAM_NAME = 3         # enum: robot_model contains parameter name containing Gazebo Model XML\n"
    "uint32 URDF_FILE_NAME        = 4         # enum: robot_model contains file name containing URDF XML\n"
    "uint32 GAZEBO_XML_FILE_NAME  = 5         # enum: robot_model contains file name containing Gazebo Model XML\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + model_name.length(); // model_name
    __l += 4 + robot_model.length(); // robot_model
    __l += 4; // xml_type
    __l += 4 + robot_namespace.length(); // robot_namespace
    __l += initial_pose.serializationLength(); // initial_pose
    __l += 0; // disable_urdf_joint_limits
    __l += 0; // URDF
    __l += 0; // GAZEBO_XML
    __l += 0; // URDF_PARAM_NAME
    __l += 0; // GAZEBO_XML_PARAM_NAME
    __l += 0; // URDF_FILE_NAME
    __l += 0; // GAZEBO_XML_FILE_NAME
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_model_name_len = model_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_model_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, model_name.c_str(), __ros_model_name_len);
    unsigned __ros_robot_model_len = robot_model.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_robot_model_len);
    SROS_SERIALIZE_BUFFER(write_ptr, robot_model.c_str(), __ros_robot_model_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, xml_type);
    unsigned __ros_robot_namespace_len = robot_namespace.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_robot_namespace_len);
    SROS_SERIALIZE_BUFFER(write_ptr, robot_namespace.c_str(), __ros_robot_namespace_len);
    write_ptr = initial_pose.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_model_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_model_name_len);
    model_name = std::string((const char *)read_ptr, __ros_model_name_len);
    read_ptr += __ros_model_name_len;
    unsigned __ros_robot_model_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_robot_model_len);
    robot_model = std::string((const char *)read_ptr, __ros_robot_model_len);
    read_ptr += __ros_robot_model_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, xml_type);
    unsigned __ros_robot_namespace_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_robot_namespace_len);
    robot_namespace = std::string((const char *)read_ptr, __ros_robot_namespace_len);
    read_ptr += __ros_robot_namespace_len;
    read_ptr = initial_pose.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<GazeboModel> GazeboModelPtr;
typedef boost::shared_ptr<GazeboModel const> GazeboModelConstPtr;


}

#endif
