/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/simulator_gazebo/gazebo_plugins/msg/ModelJointsState.msg.  Do not edit! */
#ifndef GAZEBO_PLUGINS_MODELJOINTSSTATE_H
#define GAZEBO_PLUGINS_MODELJOINTSSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"

namespace gazebo_plugins
{

//! \htmlinclude ModelJointsState.msg.html

class ModelJointsState : public ros::Message
{
public:
  typedef boost::shared_ptr<ModelJointsState> Ptr;
  typedef boost::shared_ptr<ModelJointsState const> ConstPtr;

  typedef std::vector<geometry_msgs::Pose> _model_pose_type;
  typedef std::vector<std::string> _joint_names_type;
  typedef std::vector<double> _joint_positions_type;

  std::vector<geometry_msgs::Pose> model_pose;
  std::vector<std::string> joint_names;
  std::vector<double> joint_positions;

  ModelJointsState() : ros::Message()
  {
  }
  ModelJointsState(const ModelJointsState &copy) : ros::Message()
  {
    (void)copy;
    model_pose = copy.model_pose;
    joint_names = copy.joint_names;
    joint_positions = copy.joint_positions;
  }
  ModelJointsState &operator =(const ModelJointsState &copy)
  {
    if (this == &copy)
      return *this;
    model_pose.clear();
    joint_names.clear();
    joint_positions.clear();
    model_pose = copy.model_pose;
    joint_names = copy.joint_names;
    joint_positions = copy.joint_positions;
    return *this;
  }
  virtual ~ModelJointsState() 
  {
    model_pose.clear();
    joint_names.clear();
    joint_positions.clear();
  }
  inline static std::string __s_getDataType() { return std::string("gazebo_plugins/ModelJointsState"); }
  inline static std::string __s_getMD5Sum() { return std::string("f700a74958b6566fae4cd77fbb80ffd4"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "geometry_msgs/Pose[] model_pose                          # set as single element array if user wishes to specify model pose, otherwise, leave empty\n"
    "string[] joint_names                                     # list of joint names\n"
    "float64[] joint_positions                                 # list of desired joint positions, should match joint_names\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_model_pose_size(uint32_t __ros_new_size)
  {
    this->model_pose.resize(__ros_new_size);
  }
  inline uint32_t get_model_pose_size() const { return model_pose.size(); }
  inline void get_model_pose_vec (std::vector<geometry_msgs::Pose> &__ros_vec) const
  {
    __ros_vec = this->model_pose;
  }
  inline void set_model_pose_vec(const std::vector<geometry_msgs::Pose> &__ros_vec)
  {
    this->model_pose = __ros_vec;
  }
  void set_joint_names_size(uint32_t __ros_new_size)
  {
    this->joint_names.resize(__ros_new_size);
  }
  inline uint32_t get_joint_names_size() const { return joint_names.size(); }
  uint32_t calc_joint_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_names_size = joint_names.size();
    for (size_t i = 0; i < joint_names_size; i++)
      l += 4 + joint_names[i].length();
    return l;
  }
  inline void get_joint_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->joint_names;
  }
  inline void set_joint_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->joint_names = __ros_vec;
  }
  void set_joint_positions_size(uint32_t __ros_new_size)
  {
    this->joint_positions.resize(__ros_new_size);
  }
  inline uint32_t get_joint_positions_size() const { return joint_positions.size(); }
  inline void get_joint_positions_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->joint_positions;
  }
  inline void set_joint_positions_vec(const std::vector<double> &__ros_vec)
  {
    this->joint_positions = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + (model_pose.size() ? model_pose.size() * model_pose[0].serializationLength() : 0); // model_pose
    __l += 4 + calc_joint_names_array_serialization_len(); // joint_names
    __l += 4 + (joint_positions.size() ? joint_positions.size() * 8 : 0); // joint_positions
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __model_pose_size = model_pose.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __model_pose_size);
    for (size_t i = 0; i < __model_pose_size; i++)
      write_ptr = model_pose[i].serialize(write_ptr, seq);
    uint32_t __joint_names_size = joint_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len = joint_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_joint_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, joint_names[i].c_str(), __ros_joint_names_i__len);
    }
    uint32_t __joint_positions_size = joint_positions.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_positions_size);
    memcpy(write_ptr, &joint_positions[0], sizeof(double) * __joint_positions_size);
    write_ptr += sizeof(double) * __joint_positions_size;
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __model_pose_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __model_pose_size);
    set_model_pose_size(__model_pose_size);
    for (size_t i = 0; i < __model_pose_size; i++)
      read_ptr = model_pose[i].deserialize(read_ptr);
    uint32_t __joint_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_names_size);
    set_joint_names_size(__joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_joint_names_i__len);
    joint_names[i] = std::string((const char *)read_ptr, __ros_joint_names_i__len);
    read_ptr += __ros_joint_names_i__len;
    }
    uint32_t __joint_positions_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_positions_size);
    set_joint_positions_size(__joint_positions_size);
    memcpy(&joint_positions[0], read_ptr, sizeof(double) * __joint_positions_size);
    read_ptr += sizeof(double) * __joint_positions_size;
    return read_ptr;
  }
};

typedef boost::shared_ptr<ModelJointsState> ModelJointsStatePtr;
typedef boost::shared_ptr<ModelJointsState const> ModelJointsStateConstPtr;


}

#endif
