/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/simulator_gazebo/gazebo_plugins/msg/WorldState.msg.  Do not edit! */
#ifndef GAZEBO_PLUGINS_WORLDSTATE_H
#define GAZEBO_PLUGINS_WORLDSTATE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/Vector3.h"
#include "geometry_msgs/Twist.h"
#include "geometry_msgs/Wrench.h"

namespace gazebo_plugins
{

//! \htmlinclude WorldState.msg.html

class WorldState : public ros::Message
{
public:
  typedef boost::shared_ptr<WorldState> Ptr;
  typedef boost::shared_ptr<WorldState const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<std::string> _name_type;
  typedef std::vector<geometry_msgs::Pose> _pose_type;
  typedef std::vector<geometry_msgs::Twist> _twist_type;
  typedef std::vector<geometry_msgs::Wrench> _wrench_type;

  roslib::Header header;
  std::vector<std::string> name;
  std::vector<geometry_msgs::Pose> pose;
  std::vector<geometry_msgs::Twist> twist;
  std::vector<geometry_msgs::Wrench> wrench;

  WorldState() : ros::Message()
  {
  }
  WorldState(const WorldState &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    name = copy.name;
    pose = copy.pose;
    twist = copy.twist;
    wrench = copy.wrench;
  }
  WorldState &operator =(const WorldState &copy)
  {
    if (this == &copy)
      return *this;
    name.clear();
    pose.clear();
    twist.clear();
    wrench.clear();
    header = copy.header;
    name = copy.name;
    pose = copy.pose;
    twist = copy.twist;
    wrench = copy.wrench;
    return *this;
  }
  virtual ~WorldState() 
  {
    name.clear();
    pose.clear();
    twist.clear();
    wrench.clear();
  }
  inline static std::string __s_getDataType() { return std::string("gazebo_plugins/WorldState"); }
  inline static std::string __s_getMD5Sum() { return std::string("de1a9de3ab7ba97ac0e9ec01a4eb481e"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This is a message that holds data necessary to reconstruct a snapshot of the world\n"
    "#\n"
    "# = Approach to Message Passing =\n"
    "# The state of the world is defined by either\n"
    "#   1. Inertial Model pose, twist\n"
    "#      * kinematic data - connectivity graph from Model to each Link\n"
    "#      * joint angles\n"
    "#      * joint velocities\n"
    "#      * Applied forces - Body wrench\n"
    "#        * relative transform from Body to each collision Geom\n"
    "# Or\n"
    "#   2. Inertial (absolute) Body pose, twist, wrench\n"
    "#      * relative transform from Body to each collision Geom - constant, so not sent over wire\n"
    "#      * back compute from canonical body info to get Model pose and twist.\n"
    "#\n"
    "# Chooing (2.) because it matches most physics engines out there\n"
    "#   and is simpler.\n"
    "#\n"
    "# = Future =\n"
    "# Consider impacts on using reduced coordinates / graph (parent/child links) approach\n"
    "#   constraint and physics solvers.\n"
    "#\n"
    "# = Application =\n"
    "# This message is used to do the following:\n"
    "#   * reconstruct the world and objects for sensor generation\n"
    "#   * stop / start simulation - need pose, twist, wrench of each body\n"
    "#   * collision detection - need pose of each collision geometry.  velocity/acceleration if \n"
    "#\n"
    "# = Assumptions =\n"
    "# Assuming that each (physics) processor node locally already has\n"
    "#   * collision information - Trimesh for Geoms, etc\n"
    "#   * relative transforms from Body to Geom - this is assumed to be fixed, do not send oved wire\n"
    "#   * inertial information - does not vary in time\n"
    "#   * visual information - does not vary in time\n"
    "#\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "geometry_msgs/Pose[] pose\n"
    "geometry_msgs/Twist[] twist\n"
    "geometry_msgs/Wrench[] wrench\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Twist\n"
    "# This expresses velocity in free space broken into it's linear and angular parts. \n"
    "Vector3  linear\n"
    "Vector3  angular\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Vector3\n"
    "# This represents a vector in free space. \n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Wrench\n"
    "# This represents force in free space, seperated into \n"
    "# it's linear and angular parts.  \n"
    "Vector3  force\n"
    "Vector3  torque\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_name_size(uint32_t __ros_new_size)
  {
    this->name.resize(__ros_new_size);
  }
  inline uint32_t get_name_size() const { return name.size(); }
  uint32_t calc_name_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t name_size = name.size();
    for (size_t i = 0; i < name_size; i++)
      l += 4 + name[i].length();
    return l;
  }
  inline void get_name_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->name;
  }
  inline void set_name_vec(const std::vector<std::string> &__ros_vec)
  {
    this->name = __ros_vec;
  }
  void set_pose_size(uint32_t __ros_new_size)
  {
    this->pose.resize(__ros_new_size);
  }
  inline uint32_t get_pose_size() const { return pose.size(); }
  inline void get_pose_vec (std::vector<geometry_msgs::Pose> &__ros_vec) const
  {
    __ros_vec = this->pose;
  }
  inline void set_pose_vec(const std::vector<geometry_msgs::Pose> &__ros_vec)
  {
    this->pose = __ros_vec;
  }
  void set_twist_size(uint32_t __ros_new_size)
  {
    this->twist.resize(__ros_new_size);
  }
  inline uint32_t get_twist_size() const { return twist.size(); }
  inline void get_twist_vec (std::vector<geometry_msgs::Twist> &__ros_vec) const
  {
    __ros_vec = this->twist;
  }
  inline void set_twist_vec(const std::vector<geometry_msgs::Twist> &__ros_vec)
  {
    this->twist = __ros_vec;
  }
  void set_wrench_size(uint32_t __ros_new_size)
  {
    this->wrench.resize(__ros_new_size);
  }
  inline uint32_t get_wrench_size() const { return wrench.size(); }
  inline void get_wrench_vec (std::vector<geometry_msgs::Wrench> &__ros_vec) const
  {
    __ros_vec = this->wrench;
  }
  inline void set_wrench_vec(const std::vector<geometry_msgs::Wrench> &__ros_vec)
  {
    this->wrench = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + calc_name_array_serialization_len(); // name
    __l += 4 + (pose.size() ? pose.size() * pose[0].serializationLength() : 0); // pose
    __l += 4 + (twist.size() ? twist.size() * twist[0].serializationLength() : 0); // twist
    __l += 4 + (wrench.size() ? wrench.size() * wrench[0].serializationLength() : 0); // wrench
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __name_size = name.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __name_size);
    for (size_t i = 0; i < __name_size; i++)
    {
      unsigned __ros_name_i__len = name[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_name_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, name[i].c_str(), __ros_name_i__len);
    }
    uint32_t __pose_size = pose.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __pose_size);
    for (size_t i = 0; i < __pose_size; i++)
      write_ptr = pose[i].serialize(write_ptr, seq);
    uint32_t __twist_size = twist.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __twist_size);
    for (size_t i = 0; i < __twist_size; i++)
      write_ptr = twist[i].serialize(write_ptr, seq);
    uint32_t __wrench_size = wrench.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __wrench_size);
    for (size_t i = 0; i < __wrench_size; i++)
      write_ptr = wrench[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __name_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __name_size);
    set_name_size(__name_size);
    for (size_t i = 0; i < __name_size; i++)
    {
      unsigned __ros_name_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_name_i__len);
    name[i] = std::string((const char *)read_ptr, __ros_name_i__len);
    read_ptr += __ros_name_i__len;
    }
    uint32_t __pose_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __pose_size);
    set_pose_size(__pose_size);
    for (size_t i = 0; i < __pose_size; i++)
      read_ptr = pose[i].deserialize(read_ptr);
    uint32_t __twist_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __twist_size);
    set_twist_size(__twist_size);
    for (size_t i = 0; i < __twist_size; i++)
      read_ptr = twist[i].deserialize(read_ptr);
    uint32_t __wrench_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __wrench_size);
    set_wrench_size(__wrench_size);
    for (size_t i = 0; i < __wrench_size; i++)
      read_ptr = wrench[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<WorldState> WorldStatePtr;
typedef boost::shared_ptr<WorldState const> WorldStateConstPtr;


}

#endif
