# autogenerated by genmsg_py from ContactState.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg

class ContactState(roslib.message.Message):
  _md5sum = "0810b2ddb2829d16562fb583d2db4993"
  _type = "gazebo_plugins/ContactState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string info                                   # text info on this contact
string geom1_name                             # name of contact geom1
string geom2_name                             # name of contact geom2
geometry_msgs/Wrench[] wrenches               # list of forces/torques
geometry_msgs/Vector3[] contact_positions     # list of contact position
geometry_msgs/Vector3[] contact_normals       # list of contact normals
float64[] depths                              # list of penetration depths

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, seperated into 
# it's linear and angular parts.  
Vector3  force
Vector3  torque

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['info','geom1_name','geom2_name','wrenches','contact_positions','contact_normals','depths']
  _slot_types = ['string','string','string','geometry_msgs/Wrench[]','geometry_msgs/Vector3[]','geometry_msgs/Vector3[]','float64[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   info,geom1_name,geom2_name,wrenches,contact_positions,contact_normals,depths
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ContactState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.info is None:
        self.info = ''
      if self.geom1_name is None:
        self.geom1_name = ''
      if self.geom2_name is None:
        self.geom2_name = ''
      if self.wrenches is None:
        self.wrenches = []
      if self.contact_positions is None:
        self.contact_positions = []
      if self.contact_normals is None:
        self.contact_normals = []
      if self.depths is None:
        self.depths = []
    else:
      self.info = ''
      self.geom1_name = ''
      self.geom2_name = ''
      self.wrenches = []
      self.contact_positions = []
      self.contact_normals = []
      self.depths = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.info)
      #serialize self.info
      buff.write(struct.pack('<I%ss'%length, length, self.info))
      length = len(self.geom1_name)
      #serialize self.geom1_name
      buff.write(struct.pack('<I%ss'%length, length, self.geom1_name))
      length = len(self.geom2_name)
      #serialize self.geom2_name
      buff.write(struct.pack('<I%ss'%length, length, self.geom2_name))
      #serialize self.wrenches
      length = len(self.wrenches)
      buff.write(struct.pack('<I', length))
      for val1 in self.wrenches:
        buff.write(struct.pack('<3d', val1.force.x, val1.force.y, val1.force.z))
        buff.write(struct.pack('<3d', val1.torque.x, val1.torque.y, val1.torque.z))
      #serialize self.contact_positions
      length = len(self.contact_positions)
      buff.write(struct.pack('<I', length))
      for val1 in self.contact_positions:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.contact_normals
      length = len(self.contact_normals)
      buff.write(struct.pack('<I', length))
      for val1 in self.contact_normals:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.depths
      length = len(self.depths)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.depths))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.info
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.info,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.geom1_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.geom1_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.geom2_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.geom2_name,) = struct.unpack(pattern, str[start:end])
      #deserialize self.wrenches
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.wrenches = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Wrench()
        start = end
        end += 24
        (val1.force.x, val1.force.y, val1.force.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.torque.x, val1.torque.y, val1.torque.z,) = struct.unpack('<3d',str[start:end])
        self.wrenches.append(val1)
      #deserialize self.contact_positions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.contact_positions = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.contact_positions.append(val1)
      #deserialize self.contact_normals
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.contact_normals = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.contact_normals.append(val1)
      #deserialize self.depths
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.depths = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.info)
      #serialize self.info
      buff.write(struct.pack('<I%ss'%length, length, self.info))
      length = len(self.geom1_name)
      #serialize self.geom1_name
      buff.write(struct.pack('<I%ss'%length, length, self.geom1_name))
      length = len(self.geom2_name)
      #serialize self.geom2_name
      buff.write(struct.pack('<I%ss'%length, length, self.geom2_name))
      #serialize self.wrenches
      length = len(self.wrenches)
      buff.write(struct.pack('<I', length))
      for val1 in self.wrenches:
        buff.write(struct.pack('<3d', val1.force.x, val1.force.y, val1.force.z))
        buff.write(struct.pack('<3d', val1.torque.x, val1.torque.y, val1.torque.z))
      #serialize self.contact_positions
      length = len(self.contact_positions)
      buff.write(struct.pack('<I', length))
      for val1 in self.contact_positions:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.contact_normals
      length = len(self.contact_normals)
      buff.write(struct.pack('<I', length))
      for val1 in self.contact_normals:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      #serialize self.depths
      length = len(self.depths)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.depths.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.info
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.info,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.geom1_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.geom1_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.geom2_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.geom2_name,) = struct.unpack(pattern, str[start:end])
      #deserialize self.wrenches
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.wrenches = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Wrench()
        start = end
        end += 24
        (val1.force.x, val1.force.y, val1.force.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.torque.x, val1.torque.y, val1.torque.z,) = struct.unpack('<3d',str[start:end])
        self.wrenches.append(val1)
      #deserialize self.contact_positions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.contact_positions = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.contact_positions.append(val1)
      #deserialize self.contact_normals
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.contact_normals = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Vector3()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.contact_normals.append(val1)
      #deserialize self.depths
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.depths = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

