# autogenerated by genmsg_py from ContactsState.msg. Do not edit.
import roslib.message
import struct

import gazebo_plugins.msg
import geometry_msgs.msg
import roslib.msg

class ContactsState(roslib.message.Message):
  _md5sum = "3faf37b14dd23b6abd0b6b1dfe846b7c"
  _type = "gazebo_plugins/ContactsState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header                                   # stamp
gazebo_plugins/ContactState[] states            # array of geom pairs in contact

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: gazebo_plugins/ContactState
string info                                   # text info on this contact
string geom1_name                             # name of contact geom1
string geom2_name                             # name of contact geom2
geometry_msgs/Wrench[] wrenches               # list of forces/torques
geometry_msgs/Vector3[] contact_positions     # list of contact position
geometry_msgs/Vector3[] contact_normals       # list of contact normals
float64[] depths                              # list of penetration depths

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, seperated into 
# it's linear and angular parts.  
Vector3  force
Vector3  torque

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['header','states']
  _slot_types = ['Header','gazebo_plugins/ContactState[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,states
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ContactsState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.states is None:
        self.states = []
    else:
      self.header = roslib.msg._Header.Header()
      self.states = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.states
      length = len(self.states)
      buff.write(struct.pack('<I', length))
      for val1 in self.states:
        length = len(val1.info)
        #serialize val1.info
        buff.write(struct.pack('<I%ss'%length, length, val1.info))
        length = len(val1.geom1_name)
        #serialize val1.geom1_name
        buff.write(struct.pack('<I%ss'%length, length, val1.geom1_name))
        length = len(val1.geom2_name)
        #serialize val1.geom2_name
        buff.write(struct.pack('<I%ss'%length, length, val1.geom2_name))
        #serialize val1.wrenches
        length = len(val1.wrenches)
        buff.write(struct.pack('<I', length))
        for val2 in val1.wrenches:
          buff.write(struct.pack('<3d', val2.force.x, val2.force.y, val2.force.z))
          buff.write(struct.pack('<3d', val2.torque.x, val2.torque.y, val2.torque.z))
        #serialize val1.contact_positions
        length = len(val1.contact_positions)
        buff.write(struct.pack('<I', length))
        for val2 in val1.contact_positions:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.contact_normals
        length = len(val1.contact_normals)
        buff.write(struct.pack('<I', length))
        for val2 in val1.contact_normals:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.depths
        length = len(val1.depths)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.depths))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.states
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.states = []
      for i in xrange(0, length):
        val1 = gazebo_plugins.msg.ContactState()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.info
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.info,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.geom1_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.geom1_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.geom2_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.geom2_name,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.wrenches
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.wrenches = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Wrench()
          start = end
          end += 24
          (val2.force.x, val2.force.y, val2.force.z,) = struct.unpack('<3d',str[start:end])
          start = end
          end += 24
          (val2.torque.x, val2.torque.y, val2.torque.z,) = struct.unpack('<3d',str[start:end])
          val1.wrenches.append(val2)
        #deserialize val1.contact_positions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.contact_positions = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.contact_positions.append(val2)
        #deserialize val1.contact_normals
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.contact_normals = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.contact_normals.append(val2)
        #deserialize val1.depths
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.depths = struct.unpack(pattern, str[start:end])
        self.states.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.states
      length = len(self.states)
      buff.write(struct.pack('<I', length))
      for val1 in self.states:
        length = len(val1.info)
        #serialize val1.info
        buff.write(struct.pack('<I%ss'%length, length, val1.info))
        length = len(val1.geom1_name)
        #serialize val1.geom1_name
        buff.write(struct.pack('<I%ss'%length, length, val1.geom1_name))
        length = len(val1.geom2_name)
        #serialize val1.geom2_name
        buff.write(struct.pack('<I%ss'%length, length, val1.geom2_name))
        #serialize val1.wrenches
        length = len(val1.wrenches)
        buff.write(struct.pack('<I', length))
        for val2 in val1.wrenches:
          buff.write(struct.pack('<3d', val2.force.x, val2.force.y, val2.force.z))
          buff.write(struct.pack('<3d', val2.torque.x, val2.torque.y, val2.torque.z))
        #serialize val1.contact_positions
        length = len(val1.contact_positions)
        buff.write(struct.pack('<I', length))
        for val2 in val1.contact_positions:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.contact_normals
        length = len(val1.contact_normals)
        buff.write(struct.pack('<I', length))
        for val2 in val1.contact_normals:
          buff.write(struct.pack('<3d', val2.x, val2.y, val2.z))
        #serialize val1.depths
        length = len(val1.depths)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.depths.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.states
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.states = []
      for i in xrange(0, length):
        val1 = gazebo_plugins.msg.ContactState()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.info
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.info,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.geom1_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.geom1_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.geom2_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.geom2_name,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.wrenches
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.wrenches = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Wrench()
          start = end
          end += 24
          (val2.force.x, val2.force.y, val2.force.z,) = struct.unpack('<3d',str[start:end])
          start = end
          end += 24
          (val2.torque.x, val2.torque.y, val2.torque.z,) = struct.unpack('<3d',str[start:end])
          val1.wrenches.append(val2)
        #deserialize val1.contact_positions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.contact_positions = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.contact_positions.append(val2)
        #deserialize val1.contact_normals
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.contact_normals = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Vector3()
          start = end
          end += 24
          (val2.x, val2.y, val2.z,) = struct.unpack('<3d',str[start:end])
          val1.contact_normals.append(val2)
        #deserialize val1.depths
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.depths = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.states.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

