# autogenerated by genmsg_py from GazeboModel.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg

class GazeboModel(roslib.message.Message):
  _md5sum = "d714ee18a610705f8552f4aa20321c29"
  _type = "gazebo_plugins/GazeboModel"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# This is a message that hold the data necessary to spawn a model in Gazebo
# this message is used by SpawnModel service calls to RosFactory plugin.

string model_name                        # name of the model to be spawned in Gazebo
string robot_model                       # contains either URDF or Gazebo XML robot model
uint32 xml_type                          # specifies what the content of robot_model is
string robot_namespace                   # ros namespace for all the ros interface of the model
geometry_msgs/Pose initial_pose          # initial pose in the gazebo world frame
uint32 disable_urdf_joint_limits = 0     # special flag to disable URDF joint limits
uint32 URDF                  = 0         # enum: robot_model contains XML string for an URDF model
uint32 GAZEBO_XML            = 1         # enum: robot_model contains XML string for an URDF model
uint32 URDF_PARAM_NAME       = 2         # enum: robot_model contains parameter name containing URDF XML
uint32 GAZEBO_XML_PARAM_NAME = 3         # enum: robot_model contains parameter name containing Gazebo Model XML
uint32 URDF_FILE_NAME        = 4         # enum: robot_model contains file name containing URDF XML
uint32 GAZEBO_XML_FILE_NAME  = 5         # enum: robot_model contains file name containing Gazebo Model XML


================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  # Pseudo-constants
  disable_urdf_joint_limits = 0
  URDF = 0
  GAZEBO_XML = 1
  URDF_PARAM_NAME = 2
  GAZEBO_XML_PARAM_NAME = 3
  URDF_FILE_NAME = 4
  GAZEBO_XML_FILE_NAME = 5

  __slots__ = ['model_name','robot_model','xml_type','robot_namespace','initial_pose']
  _slot_types = ['string','string','uint32','string','geometry_msgs/Pose']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   model_name,robot_model,xml_type,robot_namespace,initial_pose
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(GazeboModel, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.model_name is None:
        self.model_name = ''
      if self.robot_model is None:
        self.robot_model = ''
      if self.xml_type is None:
        self.xml_type = 0
      if self.robot_namespace is None:
        self.robot_namespace = ''
      if self.initial_pose is None:
        self.initial_pose = geometry_msgs.msg.Pose()
    else:
      self.model_name = ''
      self.robot_model = ''
      self.xml_type = 0
      self.robot_namespace = ''
      self.initial_pose = geometry_msgs.msg.Pose()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.model_name)
      #serialize self.model_name
      buff.write(struct.pack('<I%ss'%length, length, self.model_name))
      length = len(self.robot_model)
      #serialize self.robot_model
      buff.write(struct.pack('<I%ss'%length, length, self.robot_model))
      buff.write(struct.pack('<I', self.xml_type))
      length = len(self.robot_namespace)
      #serialize self.robot_namespace
      buff.write(struct.pack('<I%ss'%length, length, self.robot_namespace))
      buff.write(struct.pack('<7d', self.initial_pose.position.x, self.initial_pose.position.y, self.initial_pose.position.z, self.initial_pose.orientation.x, self.initial_pose.orientation.y, self.initial_pose.orientation.z, self.initial_pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.initial_pose is None:
        self.initial_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_model
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_model,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (self.xml_type,) = struct.unpack('<I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_namespace
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_namespace,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.initial_pose.position.x, self.initial_pose.position.y, self.initial_pose.position.z, self.initial_pose.orientation.x, self.initial_pose.orientation.y, self.initial_pose.orientation.z, self.initial_pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.model_name)
      #serialize self.model_name
      buff.write(struct.pack('<I%ss'%length, length, self.model_name))
      length = len(self.robot_model)
      #serialize self.robot_model
      buff.write(struct.pack('<I%ss'%length, length, self.robot_model))
      buff.write(struct.pack('<I', self.xml_type))
      length = len(self.robot_namespace)
      #serialize self.robot_namespace
      buff.write(struct.pack('<I%ss'%length, length, self.robot_namespace))
      buff.write(struct.pack('<7d', self.initial_pose.position.x, self.initial_pose.position.y, self.initial_pose.position.z, self.initial_pose.orientation.x, self.initial_pose.orientation.y, self.initial_pose.orientation.z, self.initial_pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.initial_pose is None:
        self.initial_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_model
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_model,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (self.xml_type,) = struct.unpack('<I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_namespace
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_namespace,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.initial_pose.position.x, self.initial_pose.position.y, self.initial_pose.position.z, self.initial_pose.orientation.x, self.initial_pose.orientation.y, self.initial_pose.orientation.z, self.initial_pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

