# autogenerated by genmsg_py from ModelJointsState.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg

class ModelJointsState(roslib.message.Message):
  _md5sum = "f700a74958b6566fae4cd77fbb80ffd4"
  _type = "gazebo_plugins/ModelJointsState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """geometry_msgs/Pose[] model_pose                          # set as single element array if user wishes to specify model pose, otherwise, leave empty
string[] joint_names                                     # list of joint names
float64[] joint_positions                                 # list of desired joint positions, should match joint_names

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['model_pose','joint_names','joint_positions']
  _slot_types = ['geometry_msgs/Pose[]','string[]','float64[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   model_pose,joint_names,joint_positions
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ModelJointsState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.model_pose is None:
        self.model_pose = []
      if self.joint_names is None:
        self.joint_names = []
      if self.joint_positions is None:
        self.joint_positions = []
    else:
      self.model_pose = []
      self.joint_names = []
      self.joint_positions = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.model_pose
      length = len(self.model_pose)
      buff.write(struct.pack('<I', length))
      for val1 in self.model_pose:
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
      #serialize self.joint_names
      length = len(self.joint_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.joint_positions
      length = len(self.joint_positions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.joint_positions))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.model_pose
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.model_pose = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Pose()
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        self.model_pose.append(val1)
      #deserialize self.joint_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.joint_names.append(val1)
      #deserialize self.joint_positions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.joint_positions = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.model_pose
      length = len(self.model_pose)
      buff.write(struct.pack('<I', length))
      for val1 in self.model_pose:
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
      #serialize self.joint_names
      length = len(self.joint_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.joint_positions
      length = len(self.joint_positions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.joint_positions.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.model_pose
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.model_pose = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Pose()
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        self.model_pose.append(val1)
      #deserialize self.joint_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.joint_names.append(val1)
      #deserialize self.joint_positions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.joint_positions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

