# autogenerated by genmsg_py from WorldState.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg

class WorldState(roslib.message.Message):
  _md5sum = "de1a9de3ab7ba97ac0e9ec01a4eb481e"
  _type = "gazebo_plugins/WorldState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This is a message that holds data necessary to reconstruct a snapshot of the world
#
# = Approach to Message Passing =
# The state of the world is defined by either
#   1. Inertial Model pose, twist
#      * kinematic data - connectivity graph from Model to each Link
#      * joint angles
#      * joint velocities
#      * Applied forces - Body wrench
#        * relative transform from Body to each collision Geom
# Or
#   2. Inertial (absolute) Body pose, twist, wrench
#      * relative transform from Body to each collision Geom - constant, so not sent over wire
#      * back compute from canonical body info to get Model pose and twist.
#
# Chooing (2.) because it matches most physics engines out there
#   and is simpler.
#
# = Future =
# Consider impacts on using reduced coordinates / graph (parent/child links) approach
#   constraint and physics solvers.
#
# = Application =
# This message is used to do the following:
#   * reconstruct the world and objects for sensor generation
#   * stop / start simulation - need pose, twist, wrench of each body
#   * collision detection - need pose of each collision geometry.  velocity/acceleration if 
#
# = Assumptions =
# Assuming that each (physics) processor node locally already has
#   * collision information - Trimesh for Geoms, etc
#   * relative transforms from Body to Geom - this is assumed to be fixed, do not send oved wire
#   * inertial information - does not vary in time
#   * visual information - does not vary in time
#

Header header

string[] name
geometry_msgs/Pose[] pose
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into it's linear and angular parts. 
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, seperated into 
# it's linear and angular parts.  
Vector3  force
Vector3  torque

"""
  __slots__ = ['header','name','pose','twist','wrench']
  _slot_types = ['Header','string[]','geometry_msgs/Pose[]','geometry_msgs/Twist[]','geometry_msgs/Wrench[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,name,pose,twist,wrench
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(WorldState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.name is None:
        self.name = []
      if self.pose is None:
        self.pose = []
      if self.twist is None:
        self.twist = []
      if self.wrench is None:
        self.wrench = []
    else:
      self.header = roslib.msg._Header.Header()
      self.name = []
      self.pose = []
      self.twist = []
      self.wrench = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.name
      length = len(self.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.pose
      length = len(self.pose)
      buff.write(struct.pack('<I', length))
      for val1 in self.pose:
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
      #serialize self.twist
      length = len(self.twist)
      buff.write(struct.pack('<I', length))
      for val1 in self.twist:
        buff.write(struct.pack('<3d', val1.linear.x, val1.linear.y, val1.linear.z))
        buff.write(struct.pack('<3d', val1.angular.x, val1.angular.y, val1.angular.z))
      #serialize self.wrench
      length = len(self.wrench)
      buff.write(struct.pack('<I', length))
      for val1 in self.wrench:
        buff.write(struct.pack('<3d', val1.force.x, val1.force.y, val1.force.z))
        buff.write(struct.pack('<3d', val1.torque.x, val1.torque.y, val1.torque.z))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.name.append(val1)
      #deserialize self.pose
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.pose = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Pose()
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        self.pose.append(val1)
      #deserialize self.twist
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.twist = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Twist()
        start = end
        end += 24
        (val1.linear.x, val1.linear.y, val1.linear.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.angular.x, val1.angular.y, val1.angular.z,) = struct.unpack('<3d',str[start:end])
        self.twist.append(val1)
      #deserialize self.wrench
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.wrench = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Wrench()
        start = end
        end += 24
        (val1.force.x, val1.force.y, val1.force.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.torque.x, val1.torque.y, val1.torque.z,) = struct.unpack('<3d',str[start:end])
        self.wrench.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      #serialize self.name
      length = len(self.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.pose
      length = len(self.pose)
      buff.write(struct.pack('<I', length))
      for val1 in self.pose:
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
      #serialize self.twist
      length = len(self.twist)
      buff.write(struct.pack('<I', length))
      for val1 in self.twist:
        buff.write(struct.pack('<3d', val1.linear.x, val1.linear.y, val1.linear.z))
        buff.write(struct.pack('<3d', val1.angular.x, val1.angular.y, val1.angular.z))
      #serialize self.wrench
      length = len(self.wrench)
      buff.write(struct.pack('<I', length))
      for val1 in self.wrench:
        buff.write(struct.pack('<3d', val1.force.x, val1.force.y, val1.force.z))
        buff.write(struct.pack('<3d', val1.torque.x, val1.torque.y, val1.torque.z))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.name.append(val1)
      #deserialize self.pose
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.pose = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Pose()
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        self.pose.append(val1)
      #deserialize self.twist
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.twist = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Twist()
        start = end
        end += 24
        (val1.linear.x, val1.linear.y, val1.linear.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.angular.x, val1.angular.y, val1.angular.z,) = struct.unpack('<3d',str[start:end])
        self.twist.append(val1)
      #deserialize self.wrench
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.wrench = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Wrench()
        start = end
        end += 24
        (val1.force.x, val1.force.y, val1.force.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.torque.x, val1.torque.y, val1.torque.z,) = struct.unpack('<3d',str[start:end])
        self.wrench.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

