# autogenerated by genmsg_py from SetModelsJointsStatesRequest.msg. Do not edit.
import roslib.message
import struct

import gazebo_plugins.msg
import geometry_msgs.msg

class SetModelsJointsStatesRequest(roslib.message.Message):
  _md5sum = "ecf71b483df7b70447575a8231727200"
  _type = "gazebo_plugins/SetModelsJointsStatesRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string[] model_names
gazebo_plugins/ModelJointsState[] model_joints_states

================================================================================
MSG: gazebo_plugins/ModelJointsState
geometry_msgs/Pose[] model_pose                          # set as single element array if user wishes to specify model pose, otherwise, leave empty
string[] joint_names                                     # list of joint names
float64[] joint_positions                                 # list of desired joint positions, should match joint_names

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['model_names','model_joints_states']
  _slot_types = ['string[]','gazebo_plugins/ModelJointsState[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   model_names,model_joints_states
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetModelsJointsStatesRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.model_names is None:
        self.model_names = []
      if self.model_joints_states is None:
        self.model_joints_states = []
    else:
      self.model_names = []
      self.model_joints_states = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.model_names
      length = len(self.model_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.model_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.model_joints_states
      length = len(self.model_joints_states)
      buff.write(struct.pack('<I', length))
      for val1 in self.model_joints_states:
        #serialize val1.model_pose
        length = len(val1.model_pose)
        buff.write(struct.pack('<I', length))
        for val2 in val1.model_pose:
          buff.write(struct.pack('<3d', val2.position.x, val2.position.y, val2.position.z))
          buff.write(struct.pack('<4d', val2.orientation.x, val2.orientation.y, val2.orientation.z, val2.orientation.w))
        #serialize val1.joint_names
        length = len(val1.joint_names)
        buff.write(struct.pack('<I', length))
        for val2 in val1.joint_names:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.joint_positions
        length = len(val1.joint_positions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.joint_positions))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.model_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.model_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.model_names.append(val1)
      #deserialize self.model_joints_states
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.model_joints_states = []
      for i in xrange(0, length):
        val1 = gazebo_plugins.msg.ModelJointsState()
        #deserialize val1.model_pose
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.model_pose = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          start = end
          end += 24
          (val2.position.x, val2.position.y, val2.position.z,) = struct.unpack('<3d',str[start:end])
          start = end
          end += 32
          (val2.orientation.x, val2.orientation.y, val2.orientation.z, val2.orientation.w,) = struct.unpack('<4d',str[start:end])
          val1.model_pose.append(val2)
        #deserialize val1.joint_names
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.joint_names.append(val2)
        #deserialize val1.joint_positions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.joint_positions = struct.unpack(pattern, str[start:end])
        self.model_joints_states.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.model_names
      length = len(self.model_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.model_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.model_joints_states
      length = len(self.model_joints_states)
      buff.write(struct.pack('<I', length))
      for val1 in self.model_joints_states:
        #serialize val1.model_pose
        length = len(val1.model_pose)
        buff.write(struct.pack('<I', length))
        for val2 in val1.model_pose:
          buff.write(struct.pack('<3d', val2.position.x, val2.position.y, val2.position.z))
          buff.write(struct.pack('<4d', val2.orientation.x, val2.orientation.y, val2.orientation.z, val2.orientation.w))
        #serialize val1.joint_names
        length = len(val1.joint_names)
        buff.write(struct.pack('<I', length))
        for val2 in val1.joint_names:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        #serialize val1.joint_positions
        length = len(val1.joint_positions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.joint_positions.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.model_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.model_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.model_names.append(val1)
      #deserialize self.model_joints_states
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.model_joints_states = []
      for i in xrange(0, length):
        val1 = gazebo_plugins.msg.ModelJointsState()
        #deserialize val1.model_pose
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.model_pose = []
        for i in xrange(0, length):
          val2 = geometry_msgs.msg.Pose()
          start = end
          end += 24
          (val2.position.x, val2.position.y, val2.position.z,) = struct.unpack('<3d',str[start:end])
          start = end
          end += 32
          (val2.orientation.x, val2.orientation.y, val2.orientation.z, val2.orientation.w,) = struct.unpack('<4d',str[start:end])
          val1.model_pose.append(val2)
        #deserialize val1.joint_names
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.joint_names.append(val2)
        #deserialize val1.joint_positions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.joint_positions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.model_joints_states.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from SetModelsJointsStatesResponse.msg. Do not edit.
import roslib.message
import struct


class SetModelsJointsStatesResponse(roslib.message.Message):
  _md5sum = "2ec6f3eff0161f4257b808b12bc830c2"
  _type = "gazebo_plugins/SetModelsJointsStatesResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success
string status_message


"""
  __slots__ = ['success','status_message']
  _slot_types = ['bool','string']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   success,status_message
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetModelsJointsStatesResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.status_message is None:
        self.status_message = ''
    else:
      self.success = False
      self.status_message = ''

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<B', self.success))
      length = len(self.status_message)
      #serialize self.status_message
      buff.write(struct.pack('<I%ss'%length, length, self.status_message))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.status_message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.status_message,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<B', self.success))
      length = len(self.status_message)
      #serialize self.status_message
      buff.write(struct.pack('<I%ss'%length, length, self.status_message))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.status_message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.status_message,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class SetModelsJointsStates(roslib.message.ServiceDefinition):
  _type          = 'gazebo_plugins/SetModelsJointsStates'
  _md5sum = 'b3f4760ee77e28f605915bcee447b72d'
  _request_class  = SetModelsJointsStatesRequest
  _response_class = SetModelsJointsStatesResponse
