# autogenerated by genmsg_py from SetPoseRequest.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import nav_msgs.msg
import roslib.msg

class SetPoseRequest(roslib.message.Message):
  _md5sum = "b2e3e5bc60333d71aad6db9918c64b22"
  _type = "gazebo_plugins/SetPoseRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """nav_msgs/Odometry pose

================================================================================
MSG: nav_msgs/Odometry
# This represents an estimate of a position and velocity in free space.  
# The pose in this message should be specified in the coordinate frame given by header.frame_id.
# The twist in this message should be specified in the coordinate frame given by the child_frame_id
Header header
string child_frame_id
geometry_msgs/PoseWithCovariance pose
geometry_msgs/TwistWithCovariance twist

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/TwistWithCovariance
# This expresses velocity in free space with uncertianty.

Twist twist

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into it's linear and angular parts. 
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['pose']
  _slot_types = ['nav_msgs/Odometry']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   pose
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetPoseRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = nav_msgs.msg.Odometry()
    else:
      self.pose = nav_msgs.msg.Odometry()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.pose.header.seq, self.pose.header.stamp.secs, self.pose.header.stamp.nsecs))
      length = len(self.pose.header.frame_id)
      #serialize self.pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.pose.header.frame_id))
      length = len(self.pose.child_frame_id)
      #serialize self.pose.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.pose.child_frame_id))
      buff.write(struct.pack('<7d', self.pose.pose.pose.position.x, self.pose.pose.pose.position.y, self.pose.pose.pose.position.z, self.pose.pose.pose.orientation.x, self.pose.pose.pose.orientation.y, self.pose.pose.pose.orientation.z, self.pose.pose.pose.orientation.w))
      #serialize self.pose.pose.covariance
      buff.write(struct.pack('<36d', *self.pose.pose.covariance))
      buff.write(struct.pack('<6d', self.pose.twist.twist.linear.x, self.pose.twist.twist.linear.y, self.pose.twist.twist.linear.z, self.pose.twist.twist.angular.x, self.pose.twist.twist.angular.y, self.pose.twist.twist.angular.z))
      #serialize self.pose.twist.covariance
      buff.write(struct.pack('<36d', *self.pose.twist.covariance))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.pose is None:
        self.pose = nav_msgs.msg.Odometry()
      end = 0
      start = end
      end += 12
      (self.pose.header.seq, self.pose.header.stamp.secs, self.pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pose.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pose.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.pose.pose.pose.position.x, self.pose.pose.pose.position.y, self.pose.pose.pose.position.z, self.pose.pose.pose.orientation.x, self.pose.pose.pose.orientation.y, self.pose.pose.pose.orientation.z, self.pose.pose.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      #deserialize self.pose.pose.covariance
      start = end
      end += 288
      self.pose.pose.covariance = struct.unpack('<36d',str[start:end])
      start = end
      end += 48
      (self.pose.twist.twist.linear.x, self.pose.twist.twist.linear.y, self.pose.twist.twist.linear.z, self.pose.twist.twist.angular.x, self.pose.twist.twist.angular.y, self.pose.twist.twist.angular.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.pose.twist.covariance
      start = end
      end += 288
      self.pose.twist.covariance = struct.unpack('<36d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.pose.header.seq, self.pose.header.stamp.secs, self.pose.header.stamp.nsecs))
      length = len(self.pose.header.frame_id)
      #serialize self.pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.pose.header.frame_id))
      length = len(self.pose.child_frame_id)
      #serialize self.pose.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.pose.child_frame_id))
      buff.write(struct.pack('<7d', self.pose.pose.pose.position.x, self.pose.pose.pose.position.y, self.pose.pose.pose.position.z, self.pose.pose.pose.orientation.x, self.pose.pose.pose.orientation.y, self.pose.pose.pose.orientation.z, self.pose.pose.pose.orientation.w))
      #serialize self.pose.pose.covariance
      buff.write(self.pose.pose.covariance.tostring())
      buff.write(struct.pack('<6d', self.pose.twist.twist.linear.x, self.pose.twist.twist.linear.y, self.pose.twist.twist.linear.z, self.pose.twist.twist.angular.x, self.pose.twist.twist.angular.y, self.pose.twist.twist.angular.z))
      #serialize self.pose.twist.covariance
      buff.write(self.pose.twist.covariance.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.pose is None:
        self.pose = nav_msgs.msg.Odometry()
      end = 0
      start = end
      end += 12
      (self.pose.header.seq, self.pose.header.stamp.secs, self.pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.pose.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.pose.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.pose.pose.pose.position.x, self.pose.pose.pose.position.y, self.pose.pose.pose.position.z, self.pose.pose.pose.orientation.x, self.pose.pose.pose.orientation.y, self.pose.pose.pose.orientation.z, self.pose.pose.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      #deserialize self.pose.pose.covariance
      start = end
      end += 288
      self.pose.pose.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=36)
      start = end
      end += 48
      (self.pose.twist.twist.linear.x, self.pose.twist.twist.linear.y, self.pose.twist.twist.linear.z, self.pose.twist.twist.angular.x, self.pose.twist.twist.angular.y, self.pose.twist.twist.angular.z,) = struct.unpack('<6d',str[start:end])
      #deserialize self.pose.twist.covariance
      start = end
      end += 288
      self.pose.twist.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=36)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from SetPoseResponse.msg. Do not edit.
import roslib.message
import struct


class SetPoseResponse(roslib.message.Message):
  _md5sum = "2ec6f3eff0161f4257b808b12bc830c2"
  _type = "gazebo_plugins/SetPoseResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success
string status_message


"""
  __slots__ = ['success','status_message']
  _slot_types = ['bool','string']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   success,status_message
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SetPoseResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.status_message is None:
        self.status_message = ''
    else:
      self.success = False
      self.status_message = ''

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<B', self.success))
      length = len(self.status_message)
      #serialize self.status_message
      buff.write(struct.pack('<I%ss'%length, length, self.status_message))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.status_message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.status_message,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<B', self.success))
      length = len(self.status_message)
      #serialize self.status_message
      buff.write(struct.pack('<I%ss'%length, length, self.status_message))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.status_message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.status_message,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class SetPose(roslib.message.ServiceDefinition):
  _type          = 'gazebo_plugins/SetPose'
  _md5sum = 'b302d2ba34678ac3098522ed0bd73f44'
  _request_class  = SetPoseRequest
  _response_class = SetPoseResponse
