# autogenerated by genmsg_py from SpawnModelRequest.msg. Do not edit.
import roslib.message
import struct

import gazebo_plugins.msg
import geometry_msgs.msg

class SpawnModelRequest(roslib.message.Message):
  _md5sum = "8915810c16a568ad2934526b89348967"
  _type = "gazebo_plugins/SpawnModelRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """gazebo_plugins/GazeboModel model

================================================================================
MSG: gazebo_plugins/GazeboModel
# This is a message that hold the data necessary to spawn a model in Gazebo
# this message is used by SpawnModel service calls to RosFactory plugin.

string model_name                        # name of the model to be spawned in Gazebo
string robot_model                       # contains either URDF or Gazebo XML robot model
uint32 xml_type                          # specifies what the content of robot_model is
string robot_namespace                   # ros namespace for all the ros interface of the model
geometry_msgs/Pose initial_pose          # initial pose in the gazebo world frame
uint32 disable_urdf_joint_limits = 0     # special flag to disable URDF joint limits
uint32 URDF                  = 0         # enum: robot_model contains XML string for an URDF model
uint32 GAZEBO_XML            = 1         # enum: robot_model contains XML string for an URDF model
uint32 URDF_PARAM_NAME       = 2         # enum: robot_model contains parameter name containing URDF XML
uint32 GAZEBO_XML_PARAM_NAME = 3         # enum: robot_model contains parameter name containing Gazebo Model XML
uint32 URDF_FILE_NAME        = 4         # enum: robot_model contains file name containing URDF XML
uint32 GAZEBO_XML_FILE_NAME  = 5         # enum: robot_model contains file name containing Gazebo Model XML


================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['model']
  _slot_types = ['gazebo_plugins/GazeboModel']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   model
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SpawnModelRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.model is None:
        self.model = gazebo_plugins.msg.GazeboModel()
    else:
      self.model = gazebo_plugins.msg.GazeboModel()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.model.model_name)
      #serialize self.model.model_name
      buff.write(struct.pack('<I%ss'%length, length, self.model.model_name))
      length = len(self.model.robot_model)
      #serialize self.model.robot_model
      buff.write(struct.pack('<I%ss'%length, length, self.model.robot_model))
      buff.write(struct.pack('<I', self.model.xml_type))
      length = len(self.model.robot_namespace)
      #serialize self.model.robot_namespace
      buff.write(struct.pack('<I%ss'%length, length, self.model.robot_namespace))
      buff.write(struct.pack('<7d', self.model.initial_pose.position.x, self.model.initial_pose.position.y, self.model.initial_pose.position.z, self.model.initial_pose.orientation.x, self.model.initial_pose.orientation.y, self.model.initial_pose.orientation.z, self.model.initial_pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.model is None:
        self.model = gazebo_plugins.msg.GazeboModel()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model.model_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model.model_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model.robot_model
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model.robot_model,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (self.model.xml_type,) = struct.unpack('<I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model.robot_namespace
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model.robot_namespace,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.model.initial_pose.position.x, self.model.initial_pose.position.y, self.model.initial_pose.position.z, self.model.initial_pose.orientation.x, self.model.initial_pose.orientation.y, self.model.initial_pose.orientation.z, self.model.initial_pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.model.model_name)
      #serialize self.model.model_name
      buff.write(struct.pack('<I%ss'%length, length, self.model.model_name))
      length = len(self.model.robot_model)
      #serialize self.model.robot_model
      buff.write(struct.pack('<I%ss'%length, length, self.model.robot_model))
      buff.write(struct.pack('<I', self.model.xml_type))
      length = len(self.model.robot_namespace)
      #serialize self.model.robot_namespace
      buff.write(struct.pack('<I%ss'%length, length, self.model.robot_namespace))
      buff.write(struct.pack('<7d', self.model.initial_pose.position.x, self.model.initial_pose.position.y, self.model.initial_pose.position.z, self.model.initial_pose.orientation.x, self.model.initial_pose.orientation.y, self.model.initial_pose.orientation.z, self.model.initial_pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.model is None:
        self.model = gazebo_plugins.msg.GazeboModel()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model.model_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model.model_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model.robot_model
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model.robot_model,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (self.model.xml_type,) = struct.unpack('<I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model.robot_namespace
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model.robot_namespace,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.model.initial_pose.position.x, self.model.initial_pose.position.y, self.model.initial_pose.position.z, self.model.initial_pose.orientation.x, self.model.initial_pose.orientation.y, self.model.initial_pose.orientation.z, self.model.initial_pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from SpawnModelResponse.msg. Do not edit.
import roslib.message
import struct


class SpawnModelResponse(roslib.message.Message):
  _md5sum = "2ec6f3eff0161f4257b808b12bc830c2"
  _type = "gazebo_plugins/SpawnModelResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success
string status_message


"""
  __slots__ = ['success','status_message']
  _slot_types = ['bool','string']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   success,status_message
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(SpawnModelResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
      if self.status_message is None:
        self.status_message = ''
    else:
      self.success = False
      self.status_message = ''

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<B', self.success))
      length = len(self.status_message)
      #serialize self.status_message
      buff.write(struct.pack('<I%ss'%length, length, self.status_message))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.status_message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.status_message,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<B', self.success))
      length = len(self.status_message)
      #serialize self.status_message
      buff.write(struct.pack('<I%ss'%length, length, self.status_message))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = struct.unpack('<B',str[start:end])
      self.success = bool(self.success)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.status_message
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.status_message,) = struct.unpack(pattern, str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class SpawnModel(roslib.message.ServiceDefinition):
  _type          = 'gazebo_plugins/SpawnModel'
  _md5sum = 'ce64f81e9bc82e2fce98de7d4eea3e13'
  _request_class  = SpawnModelRequest
  _response_class = SpawnModelResponse
