/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/simulator_gazebo/gazebo_plugins/srv/SpawnModel.srv.  Do not edit! */
#ifndef SRV_GAZEBO_PLUGINS_SPAWNMODEL_H
#define SRV_GAZEBO_PLUGINS_SPAWNMODEL_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "gazebo_plugins/GazeboModel.h"

namespace gazebo_plugins
{

struct SpawnModel
{

inline static std::string getDataType() { return "gazebo_plugins/SpawnModel"; }
inline static std::string getMD5Sum() { return "ce64f81e9bc82e2fce98de7d4eea3e13"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef gazebo_plugins::GazeboModel _model_type;

  gazebo_plugins::GazeboModel model;

  Request() : ros::Message()
  {
  }
  Request(const Request &copy) : ros::Message(),
    model(copy.model)
  {
    (void)copy;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    model = copy.model;
    return *this;
  }
  virtual ~Request() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("gazebo_plugins/SpawnModelRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "gazebo_plugins/GazeboModel model     # message containing a model for spawning\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("ce64f81e9bc82e2fce98de7d4eea3e13"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("gazebo_plugins/SpawnModel"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += model.serializationLength(); // model
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = model.serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = model.deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef uint8_t _success_type;
  typedef std::string _status_message_type;

  uint8_t success;
  std::string status_message;

  Response() : ros::Message(),
    success(0)
  {
  }
  Response(const Response &copy) : ros::Message(),
    success(copy.success),
    status_message(copy.status_message)
  {
    (void)copy;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    success = copy.success;
    status_message = copy.status_message;
    return *this;
  }
  virtual ~Response() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("gazebo_plugins/SpawnModelResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "bool success                         # return true if spawn successful\n"
    "string status_message                # comments if available\n"
    "\n"
    "================================================================================\n"
    "MSG: gazebo_plugins/GazeboModel\n"
    "# This is a message that hold the data necessary to spawn a model in Gazebo\n"
    "# this message is used by SpawnModel service calls to RosFactory plugin.\n"
    "\n"
    "string model_name                        # name of the model to be spawned in Gazebo\n"
    "string robot_model                       # contains either URDF or Gazebo XML robot model\n"
    "uint32 xml_type                          # specifies what the content of robot_model is\n"
    "string robot_namespace                   # ros namespace for all the ros interface of the model\n"
    "geometry_msgs/Pose initial_pose          # initial pose in the gazebo world frame\n"
    "uint32 disable_urdf_joint_limits = 0     # special flag to disable URDF joint limits\n"
    "uint32 URDF                  = 0         # enum: robot_model contains XML string for an URDF model\n"
    "uint32 GAZEBO_XML            = 1         # enum: robot_model contains XML string for an URDF model\n"
    "uint32 URDF_PARAM_NAME       = 2         # enum: robot_model contains parameter name containing URDF XML\n"
    "uint32 GAZEBO_XML_PARAM_NAME = 3         # enum: robot_model contains parameter name containing Gazebo Model XML\n"
    "uint32 URDF_FILE_NAME        = 4         # enum: robot_model contains file name containing URDF XML\n"
    "uint32 GAZEBO_XML_FILE_NAME  = 5         # enum: robot_model contains file name containing Gazebo Model XML\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("ce64f81e9bc82e2fce98de7d4eea3e13"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("gazebo_plugins/SpawnModel"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 1; // success
    __l += 4 + status_message.length(); // status_message
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, success);
    unsigned __ros_status_message_len = status_message.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_status_message_len);
    SROS_SERIALIZE_BUFFER(write_ptr, status_message.c_str(), __ros_status_message_len);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, success);
    unsigned __ros_status_message_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_status_message_len);
    status_message = std::string((const char *)read_ptr, __ros_status_message_len);
    read_ptr += __ros_status_message_len;
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
